<script lang="ts">
import Vue from 'vue';

import ComparisonPane from './comparison-pane.vue';
import TabsOverview from './tab-overview.vue';

export default Vue.extend({
  name: 'ComparisonSideBySide',
  components: {
    ComparisonPane,
    TabsOverview,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    styleForTabs: {
      type: Boolean,
      required: false,
      default: false,
    },
    projectionBaseData: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      currentTab: this.getPreSelectedTab(),
      currentCompany: 'GitLab',
      baseHarveyUrl: '/nuxt-images/competition/progress-bars/',
      progressBarAltTextBase:
        'Progress bar that shows the current feature capability as ',
    };
  },
  watch: {
    data: {
      handler() {
        this.currentTab = 0;
      },
      deep: true,
    },
  },
  methods: {
    updateURL(index) {
      this.$router.push({
        path: '',

        query: {
          ...this.$route.query,
          feature: this.data.features[index].feature,
        },
      });
    },
    getPreSelectedTab() {
      const { feature } = this.$route.query;
      if (!feature) {
        return 0;
      }
      const selectedFeature = this.data.features.findIndex(
        (tab) => tab.feature.toLowerCase() === feature.toLowerCase(),
      );
      return selectedFeature >= 0 ? selectedFeature : 0;
    },
    progressBarLegend(value: number) {
      switch (value) {
        case 0:
          return 'little or no capability';
        case 25:
          return 'basic';
        case 50:
          return 'adequate';
        case 75:
          return 'good';
        case 100:
          return 'comprehensive';
        default:
          return null;
      }
    },
    changeTab(tabIndex): void {
      this.$refs.analysis.scrollIntoView();
      this.currentTab = tabIndex;
      this.updateURL(tabIndex);
    },
    updateDropdown(title): void {
      this.$refs.analysis.scrollIntoView();
      const newIndex = this.data.features.findIndex(
        (tab) => tab.feature === title,
      );
      this.currentTab = newIndex;
      this.updateURL(newIndex);
    },
    changeCompany(company): void {
      this.currentCompany = company;
    },
    getDropdownData() {
      return this.data.features.map((tab) => {
        return tab.feature;
      });
    },
    getTabData(company) {
      let tabData = this.data.features[this.currentTab].competitor;
      if (company === 'GitLab') {
        tabData = this.data.features[this.currentTab].gitlab;
      }

      tabData.company = company;
      return tabData;
    },
    onKeyDown(keyEvent: any, tabIndex: number) {
      switch (keyEvent.key) {
        case 'ArrowUp':
          this.moveFocusToPreviousTab(tabIndex);
          break;

        case 'ArrowDown':
          this.moveFocusToNextTab(tabIndex);
          break;

        case 'Home':
          this.moveFocusToTab(0);
          break;

        case 'End':
          this.moveFocusToTab((this as any).$refs.tabsRefs.length - 1);
          break;

        default:
          break;
      }
    },
    moveFocusToPreviousTab(tabIndex: number) {
      if (tabIndex === 0) {
        this.moveFocusToTab((this as any).$refs.tabsRefs.length - 1);
      } else {
        this.moveFocusToTab(tabIndex - 1);
      }
    },
    moveFocusToNextTab(tabIndex: number) {
      if (tabIndex === (this as any).$refs.tabsRefs.length - 1) {
        this.moveFocusToTab(0);
      } else {
        this.moveFocusToTab(tabIndex + 1);
      }
    },
    moveFocusToTab(tabIndex: any) {
      (this as any).$refs.tabsRefs[tabIndex].$el.focus();
    },
  },
});
</script>

<template>
  <div class="analysis-wrapper">
    <div ref="analysis" class="slp-mt-48 analysis">
      <div
        class="analysis-navigation"
        :class="{ 'disable-borders': styleForTabs }"
      >
        <div
          v-if="!styleForTabs && data.stage"
          class="analysis-navigation__title"
        >
          <SlpIcon
            class="slp-mb-8"
            size="md"
            :name="data.stage.toLowerCase()"
            :alt="`${data.stage} Icon`"
            variant="marketing"
          />
          <SlpTypography class="desktop-text" variant="heading5-bold">
            {{ data.stage }}
          </SlpTypography>
          <SlpTypography class="mobile-text" variant="body1-bold">
            {{ data.stage }}
          </SlpTypography>
        </div>
        <SlpTypography
          variant="body2-bold slp-pt-32 slp-pb-16 analysis-navigation__mobile-header"
          tag="div"
        >
          Categories
        </SlpTypography>
        <SlpDropdown
          :value="data.features[currentTab].feature"
          class="analysis-navigation__dropdown"
          name="mobileMenu"
          :options="getDropdownData()"
          @input="updateDropdown"
        />
        <nav class="analysis-tabs__container">
          <ul class="analysis-tabs">
            <li
              v-for="(tab, tabIndex) in data.features"
              :key="tab.feature"
              role="tablist"
              aria-label="analysis-tabs"
              @keydown="onKeyDown($event, tabIndex)"
            >
              <SlpButton
                :id="`${tab.feature}-control`"
                ref="tabsRefs"
                variant="ghost"
                class="analysis-tab"
                :class="{ active: tabIndex === currentTab, tabs: styleForTabs }"
                :tabindex="tabIndex === currentTab ? '' : '-1'"
                type="button"
                role="tab"
                :aria-controls="`${tab.feature}-panel`"
                :aria-selected="tabIndex === currentTab ? 'true' : 'false'"
                @click.native="changeTab(tabIndex)"
              >
                <SlpTypography variant="body2-bold">
                  {{ tab.feature }}
                </SlpTypography>
              </SlpButton>
            </li>
          </ul>
        </nav>
        <nav class="company-tabs__container">
          <ul class="company-tabs">
            <li>
              <SlpButton
                variant="ghost"
                class="company-tab"
                :class="{ active: currentCompany === 'GitLab' }"
                @click.native="changeCompany(0)"
              >
                <SlpTypography variant="body1-bold">GitLab</SlpTypography>
                <nuxt-img
                  v-if="getTabData('GitLab').coverage !== undefined"
                  class="slp-mt-8"
                  :src="`${baseHarveyUrl}${getTabData('GitLab').coverage}.svg`"
                  :alt="`${progressBarAltTextBase}${progressBarLegend(
                    getTabData('GitLab').coverge,
                  )}`"
                  format="webp"
                  quality="99"
                />
              </SlpButton>
            </li>
            <li>
              <SlpButton
                variant="ghost"
                class="company-tab"
                :class="{ active: currentCompany === 'competitor' }"
                @click.native="changeCompany(1)"
              >
                <SlpTypography variant="body1-bold">
                  {{ data.competitor_product }}
                </SlpTypography>
                <nuxt-img
                  v-if="
                    getTabData(data.competitor_product).coverage !== undefined
                  "
                  class="slp-mt-8"
                  :src="`${baseHarveyUrl}${
                    getTabData(data.competitor_product).coverage
                  }.svg`"
                  :alt="`${progressBarAltTextBase}${progressBarLegend(
                    getTabData(data.competitor_product).coverage,
                  )}`"
                  format="webp"
                  quality="99"
                />
              </SlpButton>
            </li>
          </ul>
        </nav>
      </div>
      <div
        :id="`${data.stage}-panel`"
        class="analysis-comparison"
        role="tabpanel"
        :aria-labelledby="`${data.stage}-control`"
      >
        <ComparisonPane
          class="analysis-GitLab"
          :comparison-data="getTabData('GitLab')"
          :projection-base-data="projectionBaseData"
          :stage="data.stage"
        />
        <ComparisonPane
          class="analysis-competitor"
          :class="{ 'disable-borders': styleForTabs }"
          :comparison-data="getTabData(data.competitor_product)"
        />
        <ComparisonPane
          class="analysis-mobile"
          :comparison-data="getTabData(currentCompany)"
        />
      </div>
    </div>
    <div
      v-if="
        data.overview_analysis &&
        data.gitlab_product_roadmap &&
        data.competitor_product !== 'GitHub'
      "
      class="analysis__overview"
    >
      <TabsOverview :data="data" />
    </div>
  </div>
</template>

<style scoped lang="scss">
$nav-width: 168px;
$nav-overflow: $spacing-16;

.desktop-text {
  display: initial;
  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.mobile-text {
  display: none;

  @media (max-width: $breakpoint-md) {
    display: initial;
  }
}

.company-tabs__container {
  display: none;

  @media (max-width: $breakpoint-md) {
    display: block;
  }
}

.analysis-tabs__container {
  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.company-tabs {
  display: flex;

  .company-tab {
    display: flex;
    flex-direction: column;
    transition: none;
    padding: 12px 16px;
    border-radius: 4px 4px 0 0;

    img {
      width: 90px;
    }
  }

  .active {
    background-color: $color-surface-50;
    box-shadow: 0 8px 50px #d1d0d3;
    z-index: 1001;
    clip-path: inset(-150px 0px 0px -50px);
  }
}

.analysis {
  display: grid;
  grid-template-columns: $nav-width 1fr;

  @media (max-width: $breakpoint-md) {
    display: block;
  }

  &-wrapper {
    position: relative;
    border-radius: 8px;

    @media (min-width: $breakpoint-md) {
      padding-bottom: 0;
    }
    &:before {
      content: '';
      display: block;
      width: calc(100% - 16px);
      height: 100%;
      position: absolute;
      top: 0;
      background: $color-surface-50;
      left: 16px;

      border-radius: 8px;
      @media (min-width: $breakpoint-md) {
        box-shadow: 0 8px 50px #d1d0d3;
      }
    }
    &:after {
      content: '';
      display: block;
      position: absolute;
      background: $color-surface-800;
      width: 200%;
      left: -50%;
      height: 100%;
      top: 0;
      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }
    div {
      position: relative;
      z-index: 1;
    }
  }
  &-comparison {
    display: grid;
    grid-template-columns: 1fr 1fr;
    z-index: 1000;

    @media (max-width: $breakpoint-md) {
      display: block;
      box-shadow: none;
    }
  }

  &-navigation {
    background-color: $color-surface-800;
    margin-left: $nav-overflow;
    border-radius: 8px 0 0 0;
    position: relative;
    &.disable-borders {
      margin-left: 0;
      border-radius: 0;
    }

    @media (max-width: $breakpoint-md) {
      margin-left: 0;
    }

    &__title {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      padding: $spacing-16 0;
      max-width: max-content;
      @media (min-width: $breakpoint-md) {
        padding: $spacing-32 $spacing-24 $spacing-16 $spacing-24;
        margin: 0 auto;
        padding: $spacing-32 0 0 0;
      }
      @media (max-width: $breakpoint-md) {
        .slp-icon {
          margin-right: $spacing-8;
          height: 24px;
          width: 24px;
        }
      }
      &:after {
        display: block;
        content: '';
        width: calc(100% + 16px);
        height: 100%;
        position: absolute;
        background: $color-surface-800;
        left: 0;
        top: 0;
        border-top-right-radius: 4px;
        @media (min-width: 640px) {
          width: calc(100% + 16px + 2.5vw);
        }
        @media (min-width: $breakpoint-md) {
          display: none;
        }
      }
      &:before {
        content: '';
        display: block;
        width: 100vw;
        height: 100%;
        position: absolute;
        top: 0;
        background: $color-surface-50;
        left: 0;
        @media (min-width: $breakpoint-sm) {
          left: 0;
        }
        @media (min-width: $breakpoint-md) {
          display: none;
        }
      }
      div,
      span {
        position: relative;
        z-index: 1;
        @media (max-width: $breakpoint-md) {
          line-height: 1;
        }
      }
    }

    &__dropdown {
      display: none;
      margin: 0 auto $spacing-32 auto;
      background-color: $color-surface-50;

      @media (max-width: $breakpoint-md) {
        display: block;
      }
    }

    &__mobile-header {
      display: block;
      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }
  }

  &-tabs {
    li {
      margin-top: $spacing-16;
    }

    .active {
      background-color: $color-surface-50;
      width: $nav-width;
      margin-left: -$nav-overflow;
      padding-left: 32px;
      position: relative;
      z-index: 1001;
      &.tabs {
        width: calc($nav-width + $nav-overflow);
      }
      &:before {
        content: '';
        display: block;
        position: absolute;
        width: 16px;
        height: 100%;
        left: 0;
        background: $color-surface-50;
        box-shadow: 0 8px 50px #d1d0d3;
        z-index: 1001;
        clip-path: inset(-150px 0px -50px -50px);
        border-radius: 4px 0 0 4px;
      }
    }
  }

  &-tab {
    width: 100%;
    text-align: left;
    padding: 14px $spacing-32 14px $spacing-16;
    border-radius: 4px 0 0 4px;
    transition: none;
    border-right: none;
    &:hover,
    &:focus:not(.active) {
      text-decoration: underline;
    }
  }

  &-GitLab {
    background-color: $color-surface-50;
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &-competitor {
    background-color: $color-surface-100;
    border-radius: 0 8px 0 0;
    &.disable-borders {
      border-radius: 0;
    }
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &-mobile {
    display: none;
    background: $color-surface-50;
    border-top-right-radius: 8px;

    @media (max-width: $breakpoint-md) {
      display: block;
    }
  }

  &__overview {
    grid-template-columns: 1fr 1fr;
    display: block;
    position: relative;
    z-index: 1111;
    border-top: 1px solid $color-surface-200;
    border-radius: 0 0 8px 8px;
    padding-bottom: 1px;
    margin-bottom: $spacing-48;
    @media (min-width: $breakpoint-md) {
      margin-left: $spacing-16;
      margin-bottom: $spacing-64;
    }
  }
}
</style>
